Table table;
Table deweyTab;
int numRows, numColumns;
int numRowsD, numColumnsD;
float[][] dataMatrix;
float[][] DeweydataMatrix;
float maxValue, minValue, maxbkValue, minbkValue, maxcdValue, mincdValue, maxdvdValue, mindvdValue, maxvhsValue, minvhsValue, maxcasValue, mincasValue;

boolean labelSwitch = false, bookSwitch = true, cdSwitch = true, dvdSwitch = true, vhsSwitch = true, casSwitch = true, showtextSwitch = true;

void setup() {

  size(1600, 900);
  surface.setResizable(true);
  table = loadTable("datedyearmedia.csv", "header");
  numRows = table.getRowCount();
  numColumns = table.getColumnCount();
  dataMatrix = new float[numColumns-1][numRows];

  for (int i=0; i<numColumns-1; i++) 
  {
    for (int j=0; j<numRows; j++) 
    {
      dataMatrix[i][j] = table.getFloat(j, i+1);
    }
  }

  // Max Value
  maxValue = max2D(dataMatrix);
  minValue = min2D(dataMatrix);
  maxbkValue = maxbk2D(dataMatrix);
  minbkValue = minbk2D(dataMatrix);
  maxcdValue = maxcd2D(dataMatrix);
  mincdValue = mincd2D(dataMatrix);
  maxdvdValue = maxdvd2D(dataMatrix);
  mindvdValue = mindvd2D(dataMatrix);
  maxvhsValue = maxvhs2D(dataMatrix);
  minvhsValue = minvhs2D(dataMatrix);
  maxcasValue = maxcas2D(dataMatrix);
  mincasValue = mincas2D(dataMatrix);
}

void draw() {

  background(0);
  float dataValue;
  float start = 0;
  float end = (2*PI)/365;
  float arcHW = 250;
  float arcHWstart = arcHW;
  float x = 1000;
  float y = 525;

  // Color
  float opacity = 0;
  noFill();

  // DRAWING ARCS

  // Select row then the columns
  // Goes: year, date, media

  for (int n=0; n<10; n++) 
  {
    for (int j=0; j<365; j++)
    {
      for (int i=0; i<numColumns-1; i++)
      {      
        // Setting the endpoint as the value I am pulling from the matrix
        //float greyscale = map(dataMatrix[i][(n*365)+j], minValue, maxValue, 255, 0);
        dataValue = dataMatrix[i][(n*365)+j];
        end = (j+1)*(2*PI/365);
        strokeWeight(1);

        // Color coordinates according to media RGBYC
        if (i == 0) 
        {
          if (bookSwitch == true)
          {
            opacity = map(dataMatrix[i][(n*365)+j], minbkValue, maxbkValue, 0, 255);
            stroke(255, 0, 0, opacity);
          }
          if (bookSwitch == false)
          {
            stroke(0, 0, 0, 0);
          }
        }
        if (i == 1)
        {
          if (cdSwitch == true)
          {
            opacity = map(dataMatrix[i][(n*365)+j], mincdValue, maxcdValue, 0, 255);
            stroke(0, 255, 0, opacity);
          }
          if (cdSwitch == false)
          {
            stroke(0, 0, 0, 0);
          }
        } 
        if (i ==2)
        {
          if (dvdSwitch == true)
          {
            opacity = map(dataMatrix[i][(n*365)+j], mindvdValue, maxdvdValue, 0, 255);
            stroke(0, 0, 255, opacity);
          }
          if (dvdSwitch == false)
          {
            stroke(0, 0, 0, 0);
          }
        } 
        if (i ==3)
        {
          if (vhsSwitch == true)
          {
            opacity = map(dataMatrix[i][(n*365)+j], minvhsValue, maxvhsValue, 0, 255);
            stroke(255, 255, 0, opacity);
          }
          if (vhsSwitch == false)
          {
            stroke(0, 0, 0, 0);
          }
        } 
        if (i ==4)
        {
          if (casSwitch == true)
          {
            opacity = map(dataMatrix[i][(n*365)+j], mincasValue, maxcasValue, 0, 255);
            stroke(0, 255, 255, opacity);
          }
          if (casSwitch == false)
          {
            stroke(0, 0, 0, 0);
          }
        } 

        arc(x, y, arcHW, arcHW, start, end);

        // Shifting for next media type
        arcHW += 10;
      }

      // Goes to the next day (finishes out the media circles for 1 year)
      start = end;
      arcHW = arcHWstart;
    }
    // Makes a new bundle of circles (a new year)
    arcHWstart += 80;
    arcHW += 80;
  }

  // TITLE
  if (showtextSwitch == true)
  {
    textSize(28);
    text("LIFE AND DEATH OF MEDIA", x-900, y-400);
    textSize(14);
    text("Daily checkouts according to media type", x-900, y-364);
    text("from the years 2007-2016", x-900, y-350);
    textSize(14);
    fill(0, 255, 255);
    rect(x-900, y+417.5, 5, 5);
    fill(255, 255, 0);
    rect(x-900, y+397.5, 5, 5);
    fill(0, 0, 255);
    rect(x-900, y+377.5, 5, 5);
    fill(0, 255, 0);
    rect(x-900, y+357.5, 5, 5);
    fill(255, 0, 0);
    rect(x-900, y+337.5, 5, 5);
    fill(255);
    text("Cassetes", x-890, y+425);
    text("VHS", x-890, y+405);
    text("DVDs", x-890, y+385);
    text("CDs", x-890, y+365);
    text("Books", x-890, y+345);
    textSize(10);
    text("Opacity is determined by the number of checkouts", x-900, y+445);
  }

  // LABELING YEARS

  textSize(8);
  fill(255);
  text("2007", x+122, y);
  text("2008", x+162, y);
  text("2009", x+202, y);
  text("2010", x+242, y);
  text("2011", x+282, y);
  text("2012", x+322, y);
  text("2013", x+362, y);
  text("2014", x+402, y);
  text("2015", x+442, y);
  text("2016", x+482, y);

  // LABELING MONTHS
  if (labelSwitch == true) 
  {
    stroke(255, 255, 255, 50);
    strokeWeight(1);
    line(x-600, y, x+600, y);
    line(x, y-600, x, y+600);
    line(x-300*sqrt(3), y-300, x+300*sqrt(3), y+300);
    line(x-300, y-300*sqrt(3), x+300, y+300*sqrt(3));
    line(x+300, y-300*sqrt(3), x-300, y+300*(sqrt(3)));
    line(x+300*sqrt(3), y-300, x-300*sqrt(3), y+300);

    textSize(12);
    text("JAN", x+600, y+150);
    text("FEB", x+450, y+450);
    text("MAR", x+200, y+500);
    text("APR", x-200, y+500);
    text("MAY", x-450, y+450);
    text("JUN", x-600, y+150);
    text("JUL", x-600, y-150);
    text("AUG", x-450, y-450);
    text("SEP", x-200, y-500);
    text("OCT", x+200, y-500);
    text("NOV", x+450, y-450);
    text("DEC", x+600, y-150);
  }
}